unit kyatisu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure showmap;
    procedure check;
    procedure init;

  end;


var
  Form1: TForm1;
  kyatis1,kyatis2,kyatis3,kamakiri1,kamakiri2,block,ito,esa,space:tbitmap;
  kyatis,la,kamakiri:tbitmap;
  screen:tbitmap;
  map: array [0..19,0..14] of integer;
  kx,ky,tx,ty:integer;
  score:integer;
  bky:integer;
  esas:integer;
  fullscreen:boolean;
implementation

{$R *.dfm}
{$R kyatis.res}



procedure TForm1.FormCreate(Sender: TObject);

begin
screen:=tbitmap.Create;
kyatis:=tbitmap.Create;
kyatis1:=tbitmap.Create;
kyatis2:=tbitmap.Create;
kyatis3:=tbitmap.Create;
kamakiri:=tbitmap.Create;
kamakiri1:=tbitmap.Create;
kamakiri2:=tbitmap.Create;
ito:=tbitmap.Create;
esa:=tbitmap.create;
block:=tbitmap.Create;
space:=tbitmap.Create;

space.Canvas.Brush.Color:=clblack;
space.Canvas.pen.Color:=clblack;
space.canvas.FillRect(rect(0,0,32,32));

kyatis1.LoadFromResourceName(hinstance,'KYATIS1');
kyatis2.LoadFromResourceName(hinstance,'KYATIS2');
kyatis3.LoadFromResourceName(hinstance,'KYATIS3');
kamakiri1.LoadFromResourceName(hInstance,'KAMAKIRI1');
kamakiri2.LoadFromResourceName(hInstance,'KAMAKIRI2');
ito.LoadFromResourceName(hInstance,'ITO');
esa.LoadFromResourceName(hInstance,'ESA');
block.LoadFromResourceName(hInstance,'BLOCK');
timer1.Interval:=600;
init;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
kyatis.free;
kamakiri.free;
kyatis1.free;
kyatis2.free;
kyatis3.free;
kamakiri1.free;
kamakiri2.free;
ito.free;
esa.free;
block.free;
space.free;
screen.free;
end;

procedure TForm1.showmap;
var
x,y:integer;
maxx,maxy:integer;
begin

screen.Canvas.Brush.Color:=clblack;
screen.Canvas.pen.Color:=clblack;

screen.Canvas.Fillrect(rect(0,0,640,480));

for x:=0 to 19 do
begin
 for y:=0 to  14 do
 begin
 if map[x,y]=0  then  screen.Canvas.Draw(x*32,y*32,space);
 if map[x,y]=1  then  screen.Canvas.Draw(x*32,y*32,block);
 if map[x,y]=2  then  screen.Canvas.Draw(x*32,y*32,esa);
 if map[x,y]=3  then  screen.Canvas.Draw(x*32,y*32,ito);

 end;
 end;

 screen.Canvas.Draw(kx*32,ky*32,kyatis);
 screen.Canvas.Draw(tx*32,ty*32,kamakiri);

if not fullscreen then
begin
form1.Left:=100;
form1.Top:=100;
form1.width:=800;
form1.Height:=518;
form1.borderstyle:=bsdialog;

Canvas.Brush.Color:=clblack;
Canvas.pen.Color:=clblack;
Canvas.Fillrect(rect(650,200,800,480));

canvas.Draw(0,0,screen);
canvas.Font.color:=clwhite;
canvas.Font.size:=20;
canvas.TextOut(650,100,'Ă!');
canvas.Font.size:=16;
canvas.TextOut(650,150,'by uF');

canvas.Font.size:=14;
canvas.TextOut(650,200,'SCORE:'+inttostr(score));
end
else

begin
//maxx:=1366;
//maxy:=768;
maxx:=Monitor.Width;
maxy:=Monitor.Height;
form1.Left:=0;
form1.Top:=0;
form1.width:=maxx;
form1.height:=maxy;
form1.borderstyle:=bsnone;

Canvas.Brush.Color:=clblack;
Canvas.pen.Color:=clblack;
Canvas.Fillrect(rect(round(maxx*0.8) ,0 ,maxx ,maxy));

canvas.stretchDraw(rect(0,0,round(maxx*0.8),maxy),screen);
canvas.Font.color:=clwhite;
canvas.Font.size:=30;
canvas.TextOut(round(maxx*0.8+10),150,'Ă!');
canvas.Font.size:=27;
canvas.TextOut(round(maxx*0.8+10),250,'by uF');

canvas.Font.size:=22;
canvas.TextOut(round(maxx*0.8+10),300,'SCORE:'+inttostr(score));
end;


end;

procedure TForm1.FormPaint(Sender: TObject);
begin
showmap;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if (map[kx,ky+1]<>1) and (map[kx,ky-1]<>3) then ky:=ky+1;


if (round(random*2+1)=2) and (map[tx,ty-1]<>1) and (ky<ty) then ty:=ty-1
else
if (map[kx,ky-1]=3) and (map[tx,ty-1]<>1) and (ky<ty) then ty:=ty-1
else
if (map[tx,ty+1]<>1) then ty:=ty+1;

if (tx>kx) and (map[tx-1,ty]<>1) then
begin
tx:=tx-1;
kamakiri.Assign(kamakiri1);
end
else
if (tx<kx) and (map[tx+1,ty]<>1) then
begin
tx:=tx+1;
kamakiri.Assign(kamakiri2);
end;

bky:=ky;


showmap;
check;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
 var
 y:integer;

  begin
  if (ssAlt in Shift) and (Key=VK_RETURN) then
begin
  fullscreen:=not fullscreen;
  key:=0;

end;

if key=vk_left then
begin
if map[kx-1,ky]<>1 then kx:=kx-1;
kyatis.Assign(kyatis1);
if (map[kx,ky+1]<>1) and (map[kx,ky-1]<>3) then ky:=ky+1;

end;

if key=vk_right then
begin
if map[kx+1,ky]<>1 then kx:=kx+1;
kyatis.Assign(kyatis2);
if (map[kx,ky+1]<>1) and (map[kx,ky-1]<>3) then ky:=ky+1;

end;


if key=vk_up then
begin
if (map[kx,ky-1]=3)  then
begin
map[kx,ky-1]:=0;
ky:=ky-1;
windows.Beep(50,80)
end;

if map[kx,ky-1]=0 then
begin
kyatis.Assign(kyatis3);
y:=ky-1;
while map[kx,y]<>1 do
begin
map[kx,y]:=3;
y:=y-1;

end;
end;



end;

check;
showmap;

end;
procedure TForm1.check;
var x,y:integer;
begin
if map[kx,ky]=2 then
begin
score:=score+100;
esas:=esas-1;
map[kx,ky]:=0;
windows.Beep(1000,125)



end;
esas:=0;
for x:=0 to 19 do
begin
 for y:=0 to  14 do
 begin
     if map[x,y]=2 then esas:=esas+1;
 end;
end;

if esas<=0 then
begin
timer1.Enabled:=false;
windows.Beep(800,125);
windows.Beep(600,125);
windows.Beep(800,125);
windows.Beep(1000,125);
showmessage('Xe[WNA!!');
timer1.Interval:=timer1.Interval-50;

init;
timer1.Enabled:=true;
end;


if map[kx,ky]=3 then map[kx,ky]:=0;


if( kx=tx) and (ky=ty) then
begin
timer1.Enabled:=false;
windows.Beep(50,125);
windows.Beep(80,125);
windows.Beep(30,125);

showmessage('Q[I[o[łB');
score:=0;
init;
timer1.Enabled:=true;

end;

end;

procedure TForm1.init;
var x,y,i:integer;
begin
randomize;
screen.Width:=640;
screen.Height:=480;



screen.Canvas.Brush.Color:=clblack;
screen.Canvas.pen.Color:=clblack;

screen.Canvas.Fillrect(rect(0,0,640,480));

for x:=0 to 19 do
begin
 for y:=0 to  14 do
 begin
     map[x,y]:=0;
 end;
end;

for x:=0 to 19 do
begin
 for y:=0 to  4 do
 begin
  map[x,y*3]:=1;
 end;
  map[x,14]:=1;
  map[x,0]:=1;
 end;
 for y:=0 to  14 do
 begin
  map[0,y]:=1;
  map[19,y]:=1;

 end;

 for i:=0 to 100 do
 begin
  x:=round(random*17)+1;
  y:=round(random*12)+1;
  map[x,y]:=0;
 end;

    esas:=0;

 for i:=0 to 50 do
 begin
  x:=round(random*17)+1;
  y:=round(random*12)+1;
  if map[x,y+1]=1 then
  begin
    map[x,y]:=2;
    esas:=esas+1;
  end;
 end;

   kx:=1;
   ky:=1;
   tx:=18;
   ty:=13;

   kyatis.Width:=32;
   kyatis.height:=32;
   kyatis.assign(kyatis2);
   kamakiri.Assign(kamakiri1);
   bky:=ky;

showmap;


end;

end.
